

MMUCR   = $d505
SR      = $dc0c
ICR     = $dc0d
CRA     = $dc0e
SCREEN  = $0400

    .word $2000

    .org $2000

    ; FSDIR and SR as input
    lda MMUCR
    and #<~$08
    sta MMUCR
    lda CRA
    and #<~$40
    sta CRA

    sei
    ; wait for SR full
 :  lda ICR
    and #$08
    beq :-

    lda SR
    tax
    lsr
    lsr
    lsr
    lsr
    jsr ntoa
    sta SCREEN
    txa
    and #$0f
    jsr ntoa
    sta SCREEN+1
    ; reset SR
    lda CRA
    ora #$40
    sta CRA
    and #<~$40
    sta CRA

    ; change background color
    inc $d020
    bne :-

    cli
    rts

ntoa:
    ora #$30
    cmp #$3a
    bcc :+
    sbc #$39
:   rts
